
import { Suspense } from "react";
import Image from "next/image";
import { Attachment } from "@/db";

export default function Post(post_content: string, attachments: Attachment[]) {
    let images = [];
    let videos = [];
    attachments.forEach(attachment => {
        if (attachment.type.type == "video") {
            attachment.urls.forEach(url => {
                videos.push(
                    <Suspense fallback={<p>加載中</p>}>
                        <video controls preload="none" aria-label="Video player">
                            <source src={url} type={attachment.type.toString()} />
                            Your browser does not support the video tag.
                        </video>
                    </Suspense>
                )
            })
        }else if (attachment.type.type="image"){
            attachment.urls.forEach(url => {
                images.push(<Image src={url} alt="Uploaded" width={300} height={200}></Image>)
            })
        }
    })
    return (<div className="w-full h-fit">
        <div>
            {post_content}
        </div>
        <div>
            <div></div>
        </div>
    </div>)
}